/*
 * DHT11.c
 *
 *   ʪȴӦúӿ
 *
 * DATA_IO  :  PB8

 */


#include "DHT11.h"




static void                           DHT11_GPIO_Config                       ( void );
static void                           DHT11_Mode_IPU                          ( void );
static void                           DHT11_Mode_Out_PP                       ( void );
static uint8_t                        DHT11_ReadByte                          ( void );





 /**
  * @brief  DHT11 ʼ
  * @param  
  * @retval 
  */
void DHT11_Init ( void )
{
    DHT11_GPIO_Config ();

    DHT11_Dout_1;               // GPIOA_15
}


/*
 * DHT11_GPIO_Config
 *   DHT11õI/O
 *   
 *   
 */
static void DHT11_GPIO_Config ( void )
{
    /*һGPIO_InitTypeDef͵Ľṹ*/
    GPIO_InitTypeDef GPIO_InitStructure;


    /*DHT11_Dout_GPIO_PORTʱ*/

    DHT11_Dout_GPIO_CLK ;

    /*ѡҪƵDHT11_Dout_GPIO_PORT*/
    GPIO_InitStructure.GPIO_Pin = DHT11_Dout_GPIO_PIN;

    /*ģʽΪͨ*/
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;

    /**/
    //GPIO_InitStructure.GPIO_Pull = GPIO_NOPULL;

    /*Ϊ50MHz */
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;

    /*ÿ⺯ʼDHT11_Dout_GPIO_PORT*/
     GPIO_Init ( DHT11_Dout_GPIO_PORT, &GPIO_InitStructure );

}


/*
 * DHT11_Mode_IPU
 *   ʹDHT11-DATAűΪģʽ
 *   
 *   
 */
static void DHT11_Mode_IPU(void)
{
      GPIO_InitTypeDef GPIO_InitStructure;

        /*ѡҪƵDHT11_Dout_GPIO_PORT*/
      GPIO_InitStructure.GPIO_Pin = DHT11_Dout_GPIO_PIN;

       /*ģʽΪģʽ*/
      GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPU ;

      /*ÿ⺯ʼDHT11_Dout_GPIO_PORT*/
       GPIO_Init(DHT11_Dout_GPIO_PORT, &GPIO_InitStructure);

}


/*
 * DHT11_Mode_Out_PP
 *   ʹDHT11-DATAűΪģʽ
 *   
 *   
 */
static void DHT11_Mode_Out_PP(void)
{
    GPIO_InitTypeDef GPIO_InitStructure;

        /*ѡҪƵDHT11_Dout_GPIO_PORT*/
    GPIO_InitStructure.GPIO_Pin = DHT11_Dout_GPIO_PIN;

    /*ģʽΪͨ*/
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;;

    /**/
    //GPIO_InitStructure.Pull = GPIO_NOPULL;

    /*Ϊ50MHz */
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;

    /*ÿ⺯ʼDHT11_Dout_GPIO_PORT*/
     GPIO_Init(DHT11_Dout_GPIO_PORT, &GPIO_InitStructure);

}


/*
 * DHT11ȡһֽڣMSB
 */
static uint8_t DHT11_ReadByte ( void )
{
    uint8_t i, temp=0;


    for(i=0;i<8;i++)
    {
        /*ÿbit50us͵ƽÿʼѯֱӻ 50us ͵ƽ */
        while(DHT11_Dout_IN()==GPIO_PIN_RESET);

        /*DHT11 26~28usĸߵƽʾ070usߵƽʾ1
         *ͨ x usĵƽ״ x ʱ
         */
        DHT11_DELAY_US(40); //ʱx us ʱҪ0ʱ伴

        if(DHT11_Dout_IN()==GPIO_PIN_SET)/* x usΪߵƽʾݡ1 */
        {
            /* ȴ1ĸߵƽ */
            while(DHT11_Dout_IN()==GPIO_PIN_SET);

            temp|=(uint8_t)(0x01<<(7-i));  //ѵ7-iλ1MSB
        }
        else     // x usΪ͵ƽʾݡ0
        {
            temp&=(uint8_t)~(0x01<<(7-i)); //ѵ7-iλ0MSB
        }
    }

    return temp;

}


/*
 * һݴΪ40bitλȳ
 * 8bit ʪ + 8bit ʪС + 8bit ¶ + 8bit ¶С + 8bit У
 */
uint8_t DHT11_Read_TempAndHumidity(DHT11_Data_TypeDef *DHT11_Data)
{
    /*ģʽ*/
    DHT11_Mode_Out_PP();
    /**/
    DHT11_Dout_0;
    /*ʱ18ms*/
    DHT11_DELAY_MS(18);

    /* ʱ30us*/
    DHT11_Dout_1;

    DHT11_DELAY_US(30);   //ʱ30us

    /*Ϊ жϴӻӦź*/
    DHT11_Mode_IPU();

    /*жϴӻǷе͵ƽӦź 粻ӦӦ*/
    if(DHT11_Dout_IN()==GPIO_PIN_RESET)
    {
        /*ѯֱӻ 80us ͵ƽ ӦźŽ*/
        while(DHT11_Dout_IN()==GPIO_PIN_RESET);

        /*ѯֱӻ 80us ߵƽ źŽ*/
        while(DHT11_Dout_IN()==GPIO_PIN_SET);

        /*ʼ*/
        DHT11_Data->humi_int= DHT11_ReadByte();

        DHT11_Data->humi_deci= DHT11_ReadByte();

        DHT11_Data->temp_int= DHT11_ReadByte();

        DHT11_Data->temp_deci= DHT11_ReadByte();

        DHT11_Data->check_sum= DHT11_ReadByte();


        /*ȡŸΪģʽ*/
        DHT11_Mode_Out_PP();
        /**/
        DHT11_Dout_1;

        /*ȡǷȷ*/
        if(DHT11_Data->check_sum == DHT11_Data->humi_int + DHT11_Data->humi_deci + DHT11_Data->temp_int+ DHT11_Data->temp_deci)
            return SUCCESS;
        else
            return ERROR;
    }

    else
        return ERROR;

}
