#include "debug.h"
#include "DHT11.h"
#include "oled.h"
#include "co_mq_7.h"

/* Global define */


/* Global Variable */
DHT11_Data_TypeDef DHT11_Data;
__IO uint16_t ADC_Value;
uint8_t exti0_status;
uint8_t DHT11_Updata;
uint8_t boot_time_ms;
uint8_t refre;
uint8_t MQ_ready;
uint8_t count;
extern float ppm;
/*******************************************************************************
* Function Name  : GPIO_Toggle_INIT
* Description    : Initializes GPIOA.0
* Input          : None
* Return         : None
*******************************************************************************/
void GPIO_Toggle_INIT(void)
{
  GPIO_InitTypeDef  GPIO_InitStructure;

  RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA,ENABLE);


  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
  GPIO_InitStructure.GPIO_Speed=GPIO_Speed_50MHz;
  GPIO_Init(GPIOA, &GPIO_InitStructure);

  //RES_Pin
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_10;
 // GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
  //GPIO_InitStructure.GPIO_Speed=GPIO_Speed_50MHz;
  GPIO_Init(GPIOA, &GPIO_InitStructure);

  //DC_Pin
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_11;
  //GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
  //GPIO_InitStructure.GPIO_Speed=GPIO_Speed_50MHz;
  GPIO_Init(GPIOA, &GPIO_InitStructure);

  //CS_Pin
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_12;
  //GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
 // GPIO_InitStructure.GPIO_Speed=GPIO_Speed_50MHz;
  GPIO_Init(GPIOA, &GPIO_InitStructure);
  //
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_3;
  GPIO_Init(GPIOA, &GPIO_InitStructure);
  //
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_2;
  GPIO_Init(GPIOA, &GPIO_InitStructure);
}
/*******************************************************************************
* Function Name  : EXTI0_INT_INIT
* Description    : Initializes EXTI0 collection.
* Input          : None
* Return         : None
*******************************************************************************/
void EXTI0_INT_INIT(void)
{
  GPIO_InitTypeDef  GPIO_InitStructure;
  EXTI_InitTypeDef EXTI_InitStructure;
  NVIC_InitTypeDef NVIC_InitStructure;

  RCC_APB2PeriphClockCmd(RCC_APB2Periph_AFIO|RCC_APB2Periph_GPIOA,ENABLE);
  //
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;         //Ϊ
  GPIO_Init(GPIOA, &GPIO_InitStructure);
  //Button
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_4;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;
  GPIO_Init(GPIOA, &GPIO_InitStructure);

   /* GPIOA ----> EXTI_Line0 */
  GPIO_EXTILineConfig(GPIO_PortSourceGPIOA,GPIO_PinSource0);
  EXTI_InitStructure.EXTI_Line=EXTI_Line0;
  EXTI_InitStructure.EXTI_Mode = EXTI_Mode_Interrupt;           //жģʽ
  EXTI_InitStructure.EXTI_Trigger = EXTI_Trigger_Rising_Falling;//½ش
  EXTI_InitStructure.EXTI_LineCmd = ENABLE;
  EXTI_Init(&EXTI_InitStructure);

  GPIO_EXTILineConfig(GPIO_PortSourceGPIOA,GPIO_PinSource4);
  EXTI_InitStructure.EXTI_Line=EXTI_Line4;
  EXTI_InitStructure.EXTI_Mode = EXTI_Mode_Interrupt;
  EXTI_InitStructure.EXTI_Trigger = EXTI_Trigger_Falling;   //½ش
  EXTI_InitStructure.EXTI_LineCmd = ENABLE;
  EXTI_Init(&EXTI_InitStructure);

  NVIC_InitStructure.NVIC_IRQChannel = EXTI0_IRQn;
  NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 1;
  NVIC_InitStructure.NVIC_IRQChannelSubPriority = 1;
  NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
  NVIC_Init(&NVIC_InitStructure);
}

void Opening_page(void);
void Main_page(void);

void DHT_ERR(void);

void SPI1_Init(void);
void ADC_Function_Init(void);
void DMA_Tx_Init(void);
void TIM2_Base_Init(void);

/*******************************************************************************
* Function Name  : main
* Description    : Main program.
* Input          : None
* Return         : None
*******************************************************************************/
int main(void)
{
	NVIC_PriorityGroupConfig(NVIC_PriorityGroup_2);
    Delay_Init();
	USART_Printf_Init(115200);
	printf("SystemClk:%d\r\n",SystemCoreClock);
	GPIO_Toggle_INIT();//ʼ
	EXTI0_INT_INIT();
	SPI1_Init();
	DHT11_Init();
	ADC_Function_Init();
	DMA_Tx_Init();
	OLED_Init();
	TIM2_Base_Init();
	Opening_page();//ҳ
	OLED_Clear();
    if(GPIO_ReadInputDataBit(GPIOA, GPIO_Pin_0) != Bit_SET)
    {
        exti0_status = 1;
    }

	ADC_SoftwareStartConvCmd(ADC1, ENABLE);             //ADCת
	TIM_Cmd(TIM2,ENABLE);           //ʹܶʱ
	while(1)
  {

	    Delay_Ms(500);
//	    printf("¶ȣ%d.%d\n\r",DHT11_Data.temp_int,DHT11_Data.temp_deci);
//	    printf("ʪȣ%d.%dRH\n\r",DHT11_Data.humi_int,DHT11_Data.humi_deci);
//	    printf("һ̼Ũȣ%dPPM\n\r",ppm);
////        OLED_DisPlay_On();      //OLED



	    if(exti0_status == 1)       //е
	    {
	        OLED_DisPlay_On();      //OLED
	        Main_page();
	     }else
	      {
	        OLED_DisPlay_Off();     //رoled

	      }

	     if(refre != 0)       //500msˢһ
	     {

	       if(DHT11_Updata > 2)   //1.5ȡһ
	         {    /*DHT11_Read_TempAndHumidityȡʪȣɹϢ*/
	           DHT11_Read_TempAndHumidity ( & DHT11_Data ) ? Main_page() : DHT_ERR();
	           DHT11_Updata = 0;
	         }

	     }
	     refre = 0;

  }
}


//ҳ
void Opening_page(void)
{
      OLED_Clear();
      OLED_ShowChinese(8,16,0,16);//һ
      OLED_ShowChinese(24,16,1,16);//
      OLED_ShowChinese(40,16,2,16);//
      OLED_ShowChinese(56,16,3,16);//̼
      OLED_ShowChinese(72,16,4,16);//
      OLED_ShowChinese(88,16,5,16);//
      OLED_ShowChinese(104,16,6,16);//
      OLED_Refresh();
      Delay_Ms(2000);
}

//
void Main_page(void)
{
      //DHT11

      OLED_ShowChinese(0,4,9,16);//
      OLED_ShowChinese(16,4,10,16);//
      OLED_ShowChar(32,4,':',16);//:
      OLED_ShowNum(40,4,DHT11_Data.temp_int,2,16);
      OLED_ShowChar(60,4,'.',16);//.
      OLED_ShowNum(68,4,DHT11_Data.temp_deci,1,16);
      OLED_ShowChar(90,4,'C',16);//C

      OLED_ShowChinese(0,20,11,16);//ʪ
      OLED_ShowChinese(16,20,10,16);//
      OLED_ShowChar(32,20,':',16);//:
      OLED_ShowNum(40,20, DHT11_Data.humi_int,2,16);
      OLED_ShowChar(60,20,'.',16);//.
      OLED_ShowNum(68,20, DHT11_Data.humi_deci,1,16);
      OLED_ShowChar(90,20,'%',16);//%
      OLED_ShowString(100,20,"RH",16);//RH
      OLED_Showdecimal(0,38,MQ7_GetPPM(),4,1,24);
      OLED_ShowString(92,46,"PPM",16);//PPM

      OLED_Refresh();
}

void DHT_ERR(void)
{

//    OLED_Clear();
//    OLED_ShowChinese(0,4,9,16);  //
//    OLED_ShowChinese(16,4,11,16);//ʪ
//    OLED_ShowChinese(32,4,10,16);//
//    OLED_ShowChinese(48,4,12,16);//
//    OLED_ShowChinese(64,4,13,16);//ȡ
//    OLED_ShowChinese(80,4,14,16);//ʧ
//    OLED_ShowChinese(96,4,15,16);//
//    OLED_ShowChar(112,4,'!',16);//!
//    OLED_Refresh();
}


